/*!
* @onoffcanvas/jquery - v0.0.2-alpha.0
* onoffcanvas jQuery package
* https://github.com/onokumus/onoffcanvas-monorepo#readme
*
* Made by onokumus <onokumus@gmail.com> (https://github.com/onokumus)
* Under MIT License
*/
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var core = require('@onoffcanvas/core');
var $ = _interopDefault(require('jquery'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var OnoffCanvas$$1 = /** @class */ (function () {
    function OnoffCanvas$$1(element, config) {
        this.element = element;
        this.config = __assign({}, core.OcDefault, config);
        this.triggerElements = $.makeArray(document.querySelectorAll("[data-toggle=\"collapse\"][href=\"#" + element.id + "\"]," +
            ("[data-toggle=\"collapse\"][data-target=\"#" + element.id + "\"]")));
        var triggers = [].slice.call(document.querySelectorAll(core.Selector.DATA_TOGGLE));
        for (var i = 0, len = triggers.length; i < len; i++) {
            var elem = triggers[i];
            var selector = core.getSelectorFromElement(elem);
            var filterElement = [].slice
                .call(document.querySelectorAll(selector))
                .filter(function (foundElem) { return foundElem === element; });
            if (selector !== null && filterElement.length > 0) {
                this.$selector = selector;
                this.triggerElements.push(elem);
            }
        }
        this.addAriaExpanded(triggers);
        this.toggle();
    }
    OnoffCanvas$$1.prototype.toggle = function () {
        if ($(this.element).hasClass(core.ClassName.SHOW)) {
            this.hide();
        }
        else {
            this.show();
        }
    };
    OnoffCanvas$$1.prototype.show = function () {
        if ($(this.element).hasClass(core.ClassName.SHOW)) {
            return;
        }
        $(this.element).addClass(core.ClassName.SHOW);
        this.addAriaExpanded(this.triggerElements);
    };
    OnoffCanvas$$1.prototype.hide = function () {
        if (!$(this.element).hasClass(core.ClassName.SHOW)) {
            return;
        }
        $(this.element).removeClass(core.ClassName.SHOW);
        this.addAriaExpanded(this.triggerElements);
    };
    OnoffCanvas$$1.prototype.addAriaExpanded = function (triggerElements) {
        var isOpen = $(this.element).hasClass(core.ClassName.SHOW);
        $(triggerElements).attr("aria-expanded", isOpen ? "true" : "false");
    };
    // tslint:disable-next-line:member-ordering
    OnoffCanvas$$1.JQI = function (config) {
        return this.each(function () {
            var $this = $(this);
            var data = $(this).data(DATA_KEY);
            var conf = __assign({}, core.OcDefault, $this.data(), (typeof config === "object" && config ? config : {}));
            if (!data) {
                data = new OnoffCanvas$$1(this, conf);
                $this.data(DATA_KEY, data);
            }
            if (typeof config === "string") {
                if (typeof data[config] === "undefined") {
                    throw new TypeError("No method named \"" + config + "\"");
                }
                data[config]();
            }
        });
    };
    return OnoffCanvas$$1;
}());

var DATA_KEY = "onoffcanvas";

exports.DATA_KEY = DATA_KEY;
exports.default = OnoffCanvas$$1;
